Subject: Re: tcp congestion policy selection link order fragile

From: Stephen Hemminger <[email-masked]>
Date: Mon, 18 Sep 2006 16:41:20 -0700

On Sun, 17 Sep 2006 16:51:50 +0200
bert hubert <[email-masked]> wrote:

> The original message Stephen reacts to below apparently never made it to the
> list, it can be found here: http://ds9a.nl/tmp/module-policy.txt
> 
> > Any body who builds in random stuff without thinking is being foolish.
> > But, if you can think of a better configuration method that isn't too
> > grotty, then go for it.
> 
> The method I'm proposing is simple enough:
> 
> 1) reno is always built-in
> 2) it is the default tcp congestion policy

No, Reno is unstable in high BDP

> 3) loading/compiling-in additional tcp congestion policies only make them
>    available
> 4) userspace is free to select a non-default tcp congestion policy at will
> 
> The implementation might be as simple as making the *first* registered
> congestion policy the default (instead of the last one) which would be reno,
> as it is in tcp_cong.o, which is probably always loaded first (as the other
> .o's need symbols that are in tcp_cong.o).
> 
> Despite what you allege about my foolishness, I maintain that a kernel that
> enables a *random policy* from the ones you compiled in, is not a sane
> kernel.
> 
> The default kernel should be as sane as possible, allowing the userspace
> people (ie, me) to mess things up to their heart's desire.
> 
> 	Bert
>